//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//Remove warning about non-Variant values being passed where a Variant should be passed
#pragma warn -lvc

//Make sure sysvari.h compiles successfully
#include <utilcls.h>

#include "WordEg2U.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  MSWord = MSWord.CreateObject("Word.Application");
  MSWord.OlePropertySet("Visible", True);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  //Should be able to say:
  //  MSWord = Unassigned
  //but MS Office apps that have VBA support don't adhere to
  //the lifetime management aspects of the MS COM spec., so...
  MSWord.OleProcedure("Quit", False);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  MSWord.OlePropertyGet("Documents").OleProcedure("Add");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  Variant Selection = MSWord.OlePropertyGet("Selection");
  //The typecast to WideString is to ensure no stray non-alpha
  //characters are given to Word, as they are otherwise
  Selection.OleProcedure("TypeText", WideString("Hello world at "));
  Selection.OleProcedure("InsertDateTime", "dddd, dd MMMM yyyy", False);
  Selection.OleProcedure("TypeParagraph");
  Selection.OleProcedure("TypeText", WideString(Memo1->Text));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
  //Obtain Word's doc stats
  Variant DocStats = MSWord.OlePropertyGet("ActiveDocument").OlePropertyGet("BuiltInDocumentProperties");
  ListBox1->Items->Clear();
  ListBox1->Items->Add("Pages: " + DocStats.OlePropertyGet("Item", "Number of pages"));
  ListBox1->Items->Add("Paragraphs: " + DocStats.OlePropertyGet("Item", "Number of paragraphs"));
  ListBox1->Items->Add("Lines: " + DocStats.OlePropertyGet("Item", "Number of lines"));
  ListBox1->Items->Add("Words: " + DocStats.OlePropertyGet("Item", "Number of words"));
  ListBox1->Items->Add("Characters: " + DocStats.OlePropertyGet("Item", "Number of characters"));
}
//---------------------------------------------------------------------------