// ************************************************************************ //
// WARNING                                                                  //
// -------                                                                  //
// The types declared in this file were generated from data read from a     //
// Type Library. If this type library is explicitly or indirectly (via      //
// another type library referring to this type library) re-imported, or the //
// 'Refresh' command of the Type Library Editor activated while editing the //
// Type Library, the contents of this file will be regenerated and all      //
// manual modifications will be lost.                                       //
// ************************************************************************ //

// C++ TLBWRTR : $Revision:   1.96.1.27  $
// File generated on 01/04/99 15:51:27 from Type Library described below.

// ************************************************************************ //
// Type Lib: D:\Conferences\ICon '99\BCB OLE\New\Server.tlb
// IID\LCID: {A6FEB520-E84A-11D2-96EC-0060978E1359}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (C:\WINDOWS\SYSTEM\STDVCL40.DLL)
// ************************************************************************ //
#ifndef   __Server_TLB_h__
#define   __Server_TLB_h__

#pragma option push -b -w-inl

#include <vcl/utilcls.h>
#if !defined(__UTILCLS_H_VERSION) || (__UTILCLS_H_VERSION < 0x0101)
#error "This file requires an newer version of the header file UTILCLS.H"
#endif

#include <olectl.h>
#include <ocidl.h>
#if defined(USING_ATLVCL) || defined(USING_ATL)
#if !defined(__TLB_NO_EVENT_WRAPPERS)
#include <atl/atlmod.h>
#endif
#endif


// *********************************************************************//
// Forward reference of some VCL types (to avoid including STDVCL.HPP)  //
// *********************************************************************//
namespace Stdvcl {class IStrings; class IStringsDisp;}
using namespace Stdvcl;

namespace Server_tlb
{

// *********************************************************************//
// HelpString: Server Library
// Version:    1.0
// *********************************************************************//


// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:      //
//   Type Libraries     : LIBID_xxxx                                    //
//   CoClasses          : CLSID_xxxx                                    //
//   DISPInterfaces     : DIID_xxxx                                     //
//   Non-DISP interfaces: IID_xxxx                                      //
// *********************************************************************//
DEFINE_GUID(LIBID_Server, 0xA6FEB520, 0xE84A, 0x11D2, 0x96, 0xEC, 0x00, 0x60, 0x97, 0x8E, 0x13, 0x59);
DEFINE_GUID(IID_IMyOleServer, 0xA6FEB521, 0xE84A, 0x11D2, 0x96, 0xEC, 0x00, 0x60, 0x97, 0x8E, 0x13, 0x59);
DEFINE_GUID(CLSID_MyOleServer, 0xA6FEB523, 0xE84A, 0x11D2, 0x96, 0xEC, 0x00, 0x60, 0x97, 0x8E, 0x13, 0x59);

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                  //
// *********************************************************************//
interface DECLSPEC_UUID("{A6FEB521-E84A-11D2-96EC-0060978E1359}") IMyOleServer;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                     //
// (NOTE: Here we map each CoClass to its Default Interface)            //
//                                                                      //
// The LIBID_OF_ macro(s) map a LIBID_OF_CoClassName to the GUID of this//
// TypeLibrary. It simplifies the updating of macros when CoClass name  //
// change.                                                              //
// *********************************************************************//
typedef IMyOleServer MyOleServer;

#define LIBID_OF_MyOleServer (&LIBID_Server)
// *********************************************************************//
// Interface: IMyOleServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {A6FEB521-E84A-11D2-96EC-0060978E1359}
// *********************************************************************//
interface IMyOleServer : public IDispatch
{
public:
  virtual HRESULT STDMETHODCALLTYPE get_CurrentTime(DATE* Value/*[out,retval]*/) = 0; // [1]

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)

  DATE __fastcall get_CurrentTime(void)
  {
    DATE Value;
    OLECHECK(this->get_CurrentTime(&Value));
    return Value;
  }


  __property   DATE            CurrentTime = {read = get_CurrentTime};

#endif //   __TLB_NO_INTERFACE_WRAPPERS

};

#if !defined(__TLB_NO_INTERFACE_WRAPPERS)
// *********************************************************************//
// SmartIntf: TCOMIMyOleServer
// Interface: IMyOleServer
// *********************************************************************//
template <class T /* IMyOleServer */ >
class TCOMIMyOleServerT : public TComInterface<IMyOleServer>, public TComInterfaceBase<IUnknown>
{
public:
  TCOMIMyOleServerT() {}
  TCOMIMyOleServerT(IMyOleServer *intf, bool addRef = false) : TComInterface<IMyOleServer>(intf, addRef) {}
  TCOMIMyOleServerT(const TCOMIMyOleServerT& src) : TComInterface<IMyOleServer>(src) {}
  TCOMIMyOleServerT& operator=(const TCOMIMyOleServerT& src) { Bind(src, true); return *this;}

  HRESULT         __fastcall get_CurrentTime(DATE* Value/*[out,retval]*/);
  DATE            __fastcall get_CurrentTime(void);

  __property   DATE            CurrentTime = {read = get_CurrentTime};
};
typedef TCOMIMyOleServerT<IMyOleServer> TCOMIMyOleServer;

// *********************************************************************//
// DispIntf:  IMyOleServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {A6FEB521-E84A-11D2-96EC-0060978E1359}
// *********************************************************************//
template<class T>
class IMyOleServerDispT : public TAutoDriver<IMyOleServer>
{
public:
  IMyOleServerDispT(){}

  IMyOleServerDispT(IMyOleServer *pintf)
  {
    TAutoDriver<IMyOleServer>::Bind(pintf);
  }

  IMyOleServerDispT& operator=(IMyOleServer *pintf)
  {
    TAutoDriver<IMyOleServer>::Bind(pintf);
    return *this;
  }

  HRESULT BindDefault(/*Binds to new instance of CoClass MyOleServer*/)
  {
    return OLECHECK(Bind(CLSID_MyOleServer));
  }

  HRESULT BindRunning(/*Binds to a running instance of CoClass MyOleServer*/)
  {
    return BindToActive(CLSID_MyOleServer);
  }

  HRESULT         __fastcall get_CurrentTime(DATE* Value/*[out,retval]*/);
  DATE            __fastcall get_CurrentTime(void);

  __property   DATE            CurrentTime = {read = get_CurrentTime};
};
typedef IMyOleServerDispT<IMyOleServer> IMyOleServerDisp;

// *********************************************************************//
// SmartIntf: TCOMIMyOleServer
// Interface: IMyOleServer
// *********************************************************************//
template <class T> HRESULT __fastcall
TCOMIMyOleServerT<T>::get_CurrentTime(DATE* Value/*[out,retval]*/)
{
  return (*this)->get_CurrentTime(Value);
}

template <class T> DATE __fastcall
TCOMIMyOleServerT<T>::get_CurrentTime(void)
{
  DATE Value;
  OLECHECK(this->get_CurrentTime(&Value));
  return Value;
}

// *********************************************************************//
// DispIntf:  IMyOleServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {A6FEB521-E84A-11D2-96EC-0060978E1359}
// *********************************************************************//
template <class T> HRESULT __fastcall
IMyOleServerDispT<T>::get_CurrentTime(DATE* Value/*[out,retval]*/)
{
  static _TDispID _dispid(*this, OLETEXT("CurrentTime"), DISPID(1));
  TAutoArgs<0> _args;
  return OutRetValSetterPtr(Value /*[VT_DATE:1]*/, _args, OlePropertyGet(_dispid, _args));
}

template <class T> DATE __fastcall
IMyOleServerDispT<T>::get_CurrentTime(void)
{
  DATE Value;
  this->get_CurrentTime(&Value);
  return Value;
}

// *********************************************************************//
// The following typedefs expose classes (named CoCoClassName) that     //
// provide static Create() and CreateRemote(LPWSTR machineName) methods //
// for creating an instance of an exposed object. These functions can   //
// be used by client wishing to automate CoClasses exposed by this      //
// typelibrary.                                                         //
// *********************************************************************//

// *********************************************************************//
// COCLASS DEFAULT INTERFACE CREATOR
// CoClass  : MyOleServer
// Interface: TCOMIMyOleServer
// *********************************************************************//
typedef TCoClassCreatorT<TCOMIMyOleServer, IMyOleServer, &CLSID_MyOleServer, &IID_IMyOleServer> CoMyOleServer;
#endif  //   __TLB_NO_INTERFACE_WRAPPERS


};     // namespace Server_tlb

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using  namespace Server_tlb;
#endif

#pragma option pop

#endif // __Server_TLB_h__
